﻿using System;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;

/// <summary>
/// Object used to comunicate with DB
/// </summary>
internal static class MailDAL
{
    private static readonly string _factoryName;
    private static readonly string _connectionString;

    static MailDAL() 
    {
        //here you can get the factory type from webconfig
        _factoryName = "System.Data.SqlClient";
        _connectionString = ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString;
    }

    internal static Email[] GetAllEmails() 
    {
        DbProviderFactory provider =  DbProviderFactories.GetFactory(_factoryName);
        using (IDbConnection con = provider.CreateConnection()) 
        {
            con.ConnectionString = _connectionString;
            using (IDbCommand command = con.CreateCommand())
            {
                //just for testing otherwise alway use SP
                command.CommandType = CommandType.Text;
                command.CommandText = "SELECT ID, name, date, subject FROM email";
                con.Open();

                IDataReader reader = command.ExecuteReader();
                try 
                {
                    if (reader.Read()) 
                    {
                        List<Email> emails = new List<Email>();

                        int idPos = reader.GetOrdinal("ID");
                        int namePos = reader.GetOrdinal("name");
                        int datePos = reader.GetOrdinal("date");
                        int subjectPos = reader.GetOrdinal("subject");

                        do
                        {
                            Email mail = new Email();
                            mail.Id = (int)reader.GetInt32(idPos);
                            mail.Name = (!reader.IsDBNull(namePos)) ? (string)reader.GetString(namePos) : string.Empty;
                            mail.Subject = (!reader.IsDBNull(subjectPos)) ? (string)reader.GetString(subjectPos) : string.Empty;
                            mail.Date = (!reader.IsDBNull(namePos)) ? (DateTime)reader.GetDateTime(datePos) : DateTime.MinValue;

                            emails.Add(mail);
                        } while (reader.Read());

                        return emails.ToArray();
                    }
                }
                catch(DbException exp)               
                {                   
                    throw;
                }
                finally
                {
                    reader.Close();
                }
            }
        }
        return new List<Email>().ToArray();
    }
}
